=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2007-02-01 23:48:08 +0000
+++ bzrlib/builtins.py	2007-02-02 04:32:56 +0000
@@ -38,6 +38,7 @@
     merge as _mod_merge,
     osutils,
     repository,
+    symbol_versioning,
     transport,
     tree as _mod_tree,
     ui,
@@ -94,6 +95,7 @@
     return tree, new_list
 
 
+@symbol_versioning.deprecated_function(symbol_versioning.zero_fifteen)
 def get_format_type(typestring):
     """Parse and return a format specifier."""
     # Have to use BzrDirMetaFormat1 directly, so that
@@ -1100,13 +1102,13 @@
                                  ' formats are: default, knit, metaweave and'
                                  ' weave. Default is knit; metaweave and'
                                  ' weave are deprecated',
+                            converter=bzrdir.format_registry.make_bzrdir,
                             registry=bzrdir.format_registry,
-                            converter=get_format_type,
                             value_switches=True),
                      ]
     def run(self, location=None, format=None):
         if format is None:
-            format = get_format_type('default')
+            format = bzrdir.format_registry.make_bzrdir('default')
         if location is None:
             location = u'.'
 
@@ -1161,7 +1163,7 @@
                                  ' metaweave and weave. Default is knit;'
                                  ' metaweave and weave are deprecated',
                             registry=bzrdir.format_registry,
-                            converter=get_format_type,
+                            converter=bzrdir.format_registry.make_bzrdir,
                             value_switches=True),
                      Option('trees',
                              help='Allows branches in repository to have'
@@ -1169,7 +1171,7 @@
     aliases = ["init-repo"]
     def run(self, location, format=None, trees=False):
         if format is None:
-            format = get_format_type('default')
+            format = bzrdir.format_registry.make_bzrdir('default')
 
         if location is None:
             location = '.'
@@ -1993,7 +1995,7 @@
                              ' Default is knit; metaweave and weave are'
                              ' deprecated',
                         registry=bzrdir.format_registry,
-                        converter=get_format_type,
+                        converter=bzrdir.format_registry.make_bzrdir,
                         value_switches=True),
                     ]
 
@@ -2001,7 +2003,7 @@
     def run(self, url='.', format=None):
         from bzrlib.upgrade import upgrade
         if format is None:
-            format = get_format_type('default')
+            format = bzrdir.format_registry.make_bzrdir('default')
         upgrade(url, format)
 
 

=== modified file 'bzrlib/bzrdir.py'
--- bzrlib/bzrdir.py	2007-01-17 14:33:15 +0000
+++ bzrlib/bzrdir.py	2007-01-26 21:56:16 +0000
@@ -2038,9 +2038,6 @@
         self.set_default(key)
         format = self.get('default')()
         assert isinstance(format, BzrDirMetaFormat1)
-        from bzrlib import repository
-        repository.RepositoryFormat._set_default_format(
-            format.repository_format)
 
     def make_bzrdir(self, key):
         return self.get(key)()

=== modified file 'bzrlib/repository.py'
--- bzrlib/repository.py	2007-01-24 11:20:17 +0000
+++ bzrlib/repository.py	2007-01-26 21:56:16 +0000
@@ -1190,19 +1190,6 @@
             raise errors.UnknownFormatError(format=format_string)
 
     @classmethod
-    @deprecated_method(symbol_versioning.zero_fourteen)
-    def set_default_format(klass, format):
-        klass._set_default_format(format)
-
-    @classmethod
-    def _set_default_format(klass, format):
-        """Set the default format for new Repository creation.
-
-        The format must already be registered.
-        """
-        format_registry.default_key = format.get_format_string()
-
-    @classmethod
     def register_format(klass, format):
         format_registry.register(format.get_format_string(), format)
 
@@ -1213,7 +1200,8 @@
     @classmethod
     def get_default_format(klass):
         """Return the current default format."""
-        return format_registry.get(format_registry.default_key)
+        from bzrlib import bzrdir
+        return bzrdir.format_registry.make_bzrdir('default').repository_format
 
     def _get_control_store(self, repo_transport, control_files):
         """Return the control store for this repository."""
@@ -1819,12 +1807,9 @@
 # formats which have no format string are not discoverable
 # and not independently creatable, so are not registered.
 RepositoryFormat.register_format(RepositoryFormat7())
-# KEEP in sync with bzrdir.format_registry default, which controls the overall
-# default control directory format
-_default_format = RepositoryFormatKnit1()
-RepositoryFormat.register_format(_default_format)
+# KEEP in sync with bzrdir.format_registry default
+RepositoryFormat.register_format(RepositoryFormatKnit1())
 RepositoryFormat.register_format(RepositoryFormatKnit2())
-RepositoryFormat._set_default_format(_default_format)
 _legacy_formats = [RepositoryFormat4(),
                    RepositoryFormat5(),
                    RepositoryFormat6()]

=== modified file 'bzrlib/tests/test_options.py'
--- bzrlib/tests/test_options.py	2007-01-17 16:32:40 +0000
+++ bzrlib/tests/test_options.py	2007-01-26 22:15:58 +0000
@@ -159,7 +159,7 @@
 
     def test_registry_converter(self):
         options = [option.RegistryOption('format', '',
-                   bzrdir.format_registry, builtins.get_format_type)]
+                   bzrdir.format_registry, bzrdir.format_registry.make_bzrdir)]
         opts, args = self.parse(options, ['--format', 'knit'])
         self.assertIsInstance(opts.format.repository_format,
                               repository.RepositoryFormatKnit1)

=== modified file 'bzrlib/tests/test_repository.py'
--- bzrlib/tests/test_repository.py	2007-01-24 07:12:09 +0000
+++ bzrlib/tests/test_repository.py	2007-01-26 21:56:16 +0000
@@ -48,26 +48,29 @@
 class TestDefaultFormat(TestCase):
 
     def test_get_set_default_format(self):
-        old_format = RepositoryFormat.get_default_format()
-        test_format = SampleRepositoryFormat()
-        RepositoryFormat.register_format(test_format)
+        old_default = bzrdir.format_registry.get('default')
+        private_default = old_default().repository_format.__class__
+        old_format = repository.RepositoryFormat.get_default_format()
+        self.assertTrue(isinstance(old_format, private_default))
+        def make_sample_bzrdir():
+            my_bzrdir = bzrdir.BzrDirMetaFormat1()
+            my_bzrdir.repository_format = SampleRepositoryFormat()
+            return my_bzrdir
+        bzrdir.format_registry.remove('default')
+        bzrdir.format_registry.register('sample', make_sample_bzrdir, '')
+        bzrdir.format_registry.set_default('sample')
+        # creating a repository should now create an instrumented dir.
         try:
-            self.applyDeprecated(symbol_versioning.zero_fourteen, 
-                RepositoryFormat.set_default_format, 
-                test_format)
-            # creating a repository should now create an instrumented dir.
-            try:
-                # the default branch format is used by the meta dir format
-                # which is not the default bzrdir format at this point
-                dir = bzrdir.BzrDirMetaFormat1().initialize('memory:///')
-                result = dir.create_repository()
-                self.assertEqual(result, 'A bzr repository dir')
-            finally:
-                self.applyDeprecated(symbol_versioning.zero_fourteen,
-                    RepositoryFormat.set_default_format, old_format)
+            # the default branch format is used by the meta dir format
+            # which is not the default bzrdir format at this point
+            dir = bzrdir.BzrDirMetaFormat1().initialize('memory:///')
+            result = dir.create_repository()
+            self.assertEqual(result, 'A bzr repository dir')
         finally:
-            RepositoryFormat.unregister_format(test_format)
-        self.assertEqual(old_format, RepositoryFormat.get_default_format())
+            bzrdir.format_registry.remove('default')
+            bzrdir.format_registry.register('default', old_default, '')
+        self.assertIsInstance(repository.RepositoryFormat.get_default_format(),
+                              old_format.__class__)
 
 
 class SampleRepositoryFormat(repository.RepositoryFormat):

